EDIT - bug #5692

Delete a person within the bulk editor deletes the person even if not saved
04/08/2016 03:56 PM - Andreas Mller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 8:00 hours
Target version: Release 4.4

Severity: critical Found in Version:

Description

After delete in agent bulk editor the bulk editor shows * to indicate it is unsaved. Closing the editor with cancel does not keep the
deleted record in the database.

This is critical because unexpected and may lead to wrong data.

see also #5706

Related issues:
Related to EDIT - bug #6174: LIE when deleting new name Closed
Related to EDIT - bug #6175: Exception when deleting transient object Closed

Associated revisions

Revision 7dce04a4 - 10/13/2016 01:15 PM - Katja Luther

fix #5692: adapt delete algorithm to annotatedLineEditor mechanisms

Revision f1a1a089 - 11/03/2016 09:40 AM - Katja Luther

fix the deletion of media in bulk editor

History

#1 - 09/02/2016 03:05 PM - Andreas Miiller
- Description updated
- Priority changed from New to Highest

#2 - 10/05/2016 12:03 PM - Andreas Miiller
- Target version changed from Unassigned CDM tickets to Release 4.4

- Estimated time set to 2:00 h

#3 - 10/07/2016 03:35 PM - Katja Luther

This is the same for taxa and names.

#4 - 10/11/2016 11:30 AM - Katja Luther
- Estimated time changed from 2:00 h to 8:00 h

The problem seems to be that we have to use the @transactional(readonly=false) and this means that the commit is called automatically after
finishing the method call.

If we remove the @transactional annotation the deletion is not commited at all because for the whole taxonService transactional is set to
readOnly=true.

Maybe it can be solved by using another parameter for this annotation.

#5 - 10/11/2016 11:43 AM - Andreas Miiller

Katja Luther wrote:
The problem seems to be that we have to use the @transactional(readonly=false) and this means that the commit is called automatically after
finishing the method call.

If we remove the @transactional annotation the deletion is not commited at all because for the whole taxonService transactional is set to
readOnly=true.
Maybe it can be solved by using another parameter for this annotation.

Why should we use another parameter? Without knowing the concrete details readOnly=false seems reasonable to me as delete is not a readonly
transaction.

#6 - 10/11/2016 11:58 AM - Katja Luther

Andreas Miller wrote:
Katja Luther wrote:

The problem seems to be that we have to use the @transactional(readonly=false) and this means that the commit is called automatically
after finishing the method call.

If we remove the @transactional annotation the deletion is not commited at all because for the whole taxonService transactional is set to
readOnly=true.

Maybe it can be solved by using another parameter for this annotation.

Why should we use another parameter? Without knowing the concrete details readOnly=false seems reasonable to me as delete is not a
readonly transaction.

But then it is saved right after calling the method it not possible to undo the delete call by not saving the editor. As long as we don't have a better
solution | will change the bulk editor that the dirty flag is not set, after deleting the object.

#7 - 10/11/2016 12:22 PM - Katja Luther

Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:

The problem seems to be that we have to use the @transactional(readonly=false) and this means that the commit is called
automatically after finishing the method call.

If we remove the @transactional annotation the deletion is not commited at all because for the whole taxonService transactional is set
to readOnly=true.

Maybe it can be solved by using another parameter for this annotation.

Why should we use another parameter? Without knowing the concrete details readOnly=false seems reasonable to me as delete is not a
readonly transaction.

But then it saved right after calling the method it not possible to undo the delete call by not saving the editor.

| don't want to change the readonly=false, but maybe it is possible to avoid the automatic commit.

#8 - 10/11/2016 02:19 PM - Andreas Miuller

Katja Luther wrote:

Katja Luther wrote:
| don't want to change the readonly=false, but maybe it is possible to avoid the automatic commit.

This is not possible. As we do have single short transactions now we can't keep them open. A possible solution is to handle it similar to the
deduplication algorithm where the entities to delete are remembered and are deleted/deduplicated only on save.
Another solution is to force save whenever a persisted object is deleted.

#9 - 10/11/2016 02:22 PM - Andreas Miiller

Whatever solution we choose please cover it with an according test.

#10 - 10/13/2016 01:07 PM - Katja Luther

| adapted the deletion to the merging and added the delete configurator to the lineAnnotation. Now the objects are annotated as deleted and the real
deletion takes place when the whole bulk editor is saved.
Before the object is annotated as deleted the isDeletable method is called.

#11 - 10/13/2016 01:15 PM - Katja Luther

- Status changed from New to Resolved
- % Done changed from 0 to 50

Applied in changeset taxeditor:commit:taxeditor|7dce04a4ef06e30769a711c8b6aceb11b2137¢c31.

#12 - 10/13/2016 01:16 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

#13 - 11/02/2016 02:54 PM - Andreas Miiller
- Related to bug #6174: LIE when deleting new name added

#14 - 11/02/2016 03:15 PM - Andreas Miiller
- Related to bug #6175: Exception when deleting transient object added

#15 - 11/02/2016 05:15 PM - Andreas Miiller
- Related to bug #6176: Creating a new Reference throws TOE (TransientObjectException) added

#16 - 11/02/2016 06:00 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

Looks like Media bulk editor is not yet fixed! All others seem to work.

#17 - 11/02/2016 06:01 PM - Andreas Miiller

While testing | found 3 other issues that might be related. #6174, #6175, #6176. Please check if they are regressions before closing this ticket.

#18 - 11/03/2016 09:41 AM - Katja Luther

The media bulk editor is fixed now see Revision f1a1a089. The problem of deleting a transient object still exists.

#19 - 11/03/2016 02:43 PM - Katja Luther
- Related to deleted (bug #6176: Creating a new Reference throws TOE (TransientObjectException))

#20 - 11/04/2016 09:25 AM - Katja Luther

- Status changed from Feedback to Resolved

The transient objects can be deleted now without exception see #6175

#21 - 11/04/2016 09:25 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

#22 - 11/08/2016 12:11 PM - Andreas Miiller
- Status changed from Resolved to Closed

- Assignee changed from Andreas Muiller to Katja Luther

Seems to be fully fixed now. Great.

#23 - 11/08/2016 12:12 PM - Andreas Miiller
- % Done changed from 50 to 100

#24 - 01/03/2017 03:03 PM - Andreas Miiller

- Private changed from Yes to No

04/19/2024 3/3


https://dev.e-taxonomy.eu/redmine/issues/6174
https://dev.e-taxonomy.eu/redmine/issues/6175
https://dev.e-taxonomy.eu/redmine/issues/6176
https://dev.e-taxonomy.eu/redmine/issues/6175
http://www.tcpdf.org

